// fun3.h - Klasa apstraktnih funkcija.

#ifndef _fun3_h_
#define _fun3_h_

#include <iostream>
using namespace std;

namespace Izvodi {
  class PFun;  // Klasa pokazivaca na funkcije.
  class Fun {                                // KLASA FUNKCIJA:
  public:
    ~Fun () {}                               // Virtuelni destruktor.
    virtual double operator() (double x) const =0; // Racunanje vrednosti.
    virtual PFun operator! () const =0;      // Stvaranje izvoda.
    virtual Fun* kopija () const =0;         // Stvaranje dinamicke kopije.
  private:
    virtual void pisi (ostream& d) const =0; // Pisanje.
    friend ostream& operator<< (ostream& d, const Fun& f)
      { f.pisi (d); return d; }
  }; // class Fun
  
  class PFun: public Fun {               // KLASA POKAZIVACA NA FUNKCIJE:
    Fun* f;                              // Pokazivana funkcija.
    void pisi (ostream& d) const { d << *f; }  // Pisanje.
  public:
    PFun (Fun* ff) { f = ff; }           // Inicijalizacija.
    PFun (const PFun& p) { f = p.f->kopija (); } // Konstruktor kopije.
    ~PFun () { delete f; }               // Destruktor.
    PFun& operator= (const PFun& p) {    // Dodela vrednosti.
      if (this != &p) { delete f; f = p.f->kopija (); }
      return *this;
    }
    double operator() (double x) const { return (*f)(x); } // Vrednost.
    PFun operator! () const { return !*f; }            // Stvaranje izvoda.
    PFun* kopija () const { return new PFun (*this); } // Dinamicka kopija.
  }; // class PFun
} // namespace Izvodi

#endif
