// integ.C - Definicija funkcije za racunanje odredjenog integrala.

#include "integ.h"

double Funkcije::integral (const Fun& f, double a, double b) {
  const int MAX_INTERVAL = 30;
  try {                                        // Pokusaj tacnog racunanja.
    return f.I(b) - f.I(a);
  } catch (GNemaInt) {                         // Priblizno racunaje.
    double dx = (b - a) / MAX_INTERVAL, s = 0;
    for (int i=0; i<MAX_INTERVAL; i++) s += f(a+i*dx);
    return s * dx;
  }
}
