// kvadar2.h - Definicija klase numerisanih kvadara.

#include <iostream>
using namespace std;

class Kvadar {
  static int ukId;       // Poslednje korisceni identifikator.
  int id;                // Identifikator kvadra.
  double a, b, c;        // Duzine ivica.
public:
  explicit Kvadar (double aa=1, double bb=1, double cc=1) // Novom kvadru
    { id = ++ukId; a = aa; b = bb; c = cc; }              //   novi broj.
  Kvadar (const Kvadar& kk)                           // Kopiji novi broj.
    { id = ++ukId; a = kk.a; b = kk.b; c = kk.c; }
  Kvadar& operator= (const Kvadar& kk)                // Levom operandu
    { a = kk.a; b = kk.b; c = kk.c; return *this; }   //   se ne menja broj.
  double V () const { return a * b * c; }                      // Zapremina.
  friend bool operator< (const Kvadar& k1, const Kvadar& k2)   // k1 < k2
    { return k1.V () < k2.V (); }
  friend istream& operator>> (istream& dd, Kvadar& kk)         // Citanje.
    { return dd >> kk.a >> kk.b >> kk.c; }
  friend ostream& operator<< (ostream& dd, const Kvadar& kk) { // Pisanje.
    return dd << 'K' << kk.id << '(' << kk.a << ','
              << kk.b << ',' << kk.c << ')';
  }
};
