// linija.h - Klasa apstraktnih linija u ravni.

#ifndef _linija_h_
#define _linija_h_

#include <iostream>
using namespace std;

namespace Linije {
  class Linija {
    static int ukId;       // Poslednje korisceni identifikator.
    int id;                // Identifikator linije.
  public:
    Linija (): id(++ukId) {}              // Nova linija dobija novi broj.
    Linija (const Linija&): id(++ukId) {} // Kopija dobija novi broj.
    Linija& operator= (const Linija&)     // Levom operandu se ne menja
      { return *this; }                   //   broj.
    virtual double operator+ () const =0; // Duzina linije.
    virtual Linija* kopija () const =0;   // Dinamicka kopija.
  protected:
    virtual void pisi (ostream& dat) const { dat << id; } // Pisanje.
    friend ostream& operator<< (ostream& dat, const Linija& lin)
      { lin.pisi (dat); return dat; }
  };
}

#endif