// log.h - Klasa za funkciju logaritam.

#ifndef _log_h_
#define _log_h_

#include "fun2.h"
#include <cmath>
using namespace std;
#include "greska.h"
using Usluge::Greska;

namespace Funkcije {
  class GNemaLog: public Greska {            // KLASA ZA GRESKU:
    double x;                                // Nedozvoljena vrednost.
  public:                                    // Konstruktori.
    GNemaLog (): Greska ("Logaritam negativnog broja") {}
    GNemaLog (double x): Greska () { this->x = x; }
    double uzmiX () const                    // Uzimanje nedozvoljene
      { return imaPoruke() ? 1 : x; }        //   vrednosti.
  private:
    void pisi (ostream &d) const {           // Pisanje poruke.
      if (imaPoruke ()) Greska::pisi(d);
      else d << "\n*** Ne postoji logaritam od " << x << " ***\a\n";
    }
  }; // class GNemaLog

  class Log: public Fun {                    // KLASA ZA FUNKCIJU:
  public:
    double operator() (double x) const {     // Racunanje funkcije.
      if (x <= 0) throw GNemaLog (x);
      return log (x);
    }
  }; // class Log
} // namespace Funkcije

#endif
