// mnogoug.C - Metode klase mnogouglova u prostoru.

#include "mnogoug.h"

void Mnogoug::pisi (ostream& d) const {          // Pisanje mnogougla.
  d << "M[";
  for (int i=0; i<n; i++) {
    if (i > 0) d << ',';
    d << niz[i];
  }
  d << ']';
}

void Mnogoug::kopiraj (const Mnogoug& m) {       // Kopiranje u objekat.
  niz = new Vektor [n = m.n];
  for (int i=0; i<n; i++) niz[i] = m.niz[i];
}

Mnogoug& Mnogoug::operator+= (const Vektor& v) { // Pomeranje mnogougla.
  for (int i=0; i<n; niz[i++]+=v);
  return *this;
}

Vektor Mnogoug::operator! () const {             // Teziste mnogougla.
  Vektor t;
  for (int i=0; i<n; t+=niz[i++]);
  return t * (1./n);
}
