// mnogoug.h - Klasa mnogouglova u prostoru.

#ifndef _mnogoug_h_
#define _mnogoug_h_

#include "figura2.h"
#include "vektor3.h"

class GIndeks {}; // KLASA ZA GRESKU: Nedozvoljeni indeks.

class Mnogoug: public Figura {
  Vektor* niz;                                // Temena mnogougla.
  int     n;                                  // Broj temena.
  void pisi (ostream& d) const;               // Pisanje.
  void kopiraj (const Mnogoug& m);            // Kopiranje u objekat.
public:
  explicit Mnogoug (int k=3)                  // Stvaranje mnogougla.
    { niz = new Vektor [n = k]; }
  Mnogoug (const Mnogoug& m) { kopiraj (m); } // Konstruktor kopije.
  ~Mnogoug () { delete [] niz; }              // Destruktor.
  Mnogoug& operator= (const Mnogoug& m) {     // Dodela vrednosti.
    if (this != &m) { delete [] niz; kopiraj (m); }
    return *this;
  }
  Mnogoug* kopija () const { return new Mnogoug (*this); } // Din. kopija.
  Mnogoug& operator+= (const Vektor& v);      // Pomeranje mnogougla.
  Vektor operator! () const;                  // Teziste.
  Vektor& operator[] (int i) {                // Pristupanje temenu:
    if (i<0 || i>=n) throw GIndeks ();        //   promenljivog objekta,
    return niz[i];
  }
  const Vektor& operator[] (int i) const {    //   nepromenljivog objekta.
    if (i<0 || i>=n) throw GIndeks ();
    return niz[i];
  }
};

#endif
