// predmet2.h - Klasa apstraktnih predmeta.

#ifndef _predmet2_h_
#define _predmet2_h_

#include <iostream>
using namespace std;

namespace Zbirke {
  class Predmet {
    static int ukId; // Poslednje korisceni identifikacioni broj.
    int id;          // Identifikacioni broj predmeta.
  public:
    Predmet () { id = ++ukId; }      // Novi predmet dobija novi broj.
    Predmet (const Predmet&)         // Kopija dobija novi broj.
      { id = ++ukId; }
    virtual ~Predmet () {}                // Virtuelni destruktor.
    Predmet& operator= (const Predmet&)   // Levom operandu se
      { return *this; }                   //   ne menja broj.
    int operator! () const { return id; } // Identifikacioni broj.
    virtual Predmet* kopija () const =0;  // Dinamicka kopija.
  private:
    virtual void pisi(ostream &d) const =0;    // Pisanje.
    friend ostream& operator<< (ostream& d, const Predmet& p)
      { p.pisi (d); return d; }
  };
} // namespace

#endif
