// proizvod.h - Klasa apstraktnih proizvoda.

#ifndef _proizvod_h_
#define _proizvod_h_

#include <iostream>
using namespace std;

namespace Fabrika {
  class Proizvod {
    static int ukId;        // Poslednje korisceni identifikator.
    int id;                 // Identifikator objekta.
  public:
    Proizvod () { id = ++ukId; }          // Novi objekat dobija novi broj.
    Proizvod (const Proizvod&) { id = ++ukId; } // Kopija dobija novi broj.
    virtual ~Proizvod () {}               // Virtuelni destruktor.
    Proizvod& operator= (const Proizvod&) // Levom operandu se ne menja br.
      { return *this; }
    int uzmiId () const { return id; }    // Dohvatanje identifikatora.
    virtual char vrsta () const =0;       // Oznaka vrste proizvoda.
    virtual double operator+ () const =0; // Zapremina proizvoda.
  protected:
    virtual void pisi (ostream& d) const { d << vrsta() << id; }// Pisanje.
    friend ostream& operator<< (ostream& d, const Proizvod& p)
      { p.pisi (d); return d; }
  }; // class Proizvod
} // namespace Fabrika

#endif
