// sklop.h - Klasa sklopova predmeta.

#ifndef _sklop_h_
#define _sklop_h_

#include "predmet3.h"
#include <vector>
using namespace std;

namespace Predmeti {
  class Sklop: public Predmet {
    vector<Predmet*> niz;                // Sadrzani predmeti.
    void kopiraj (const Sklop&);         // Kopiranje u objekat.
    void brisi ();                       // Praznjenje.
    void pisi (ostream&) const;          // Pisanje.
  public:                                // Inicijalizacija:
    Sklop () {}                          //   kao prazan sklop,
    Sklop (const Sklop& s)               //   kopijom drugog sklopa,
      : Predmet(s) { kopiraj (s); }
    Sklop (const Predmet& p)             //   kopiranjem predmeta,
      : Predmet() { niz.push_back (p.kopija()); }
    Sklop (Predmet* p)                   //   preuzimanjem predmeta.
      : Predmet() { niz.push_back (p); }
    ~Sklop () { brisi (); }              // Unistavanje.
    Sklop& operator= (const Sklop& s) {  // Dodela vrednosti.
      if (this != &s) { brisi (); Predmet::operator=(s); kopiraj (s); }
      return *this;
    }
    Sklop& operator+= (const Predmet& p) // Dodavanje predmeta kopiranjem,
      { niz.push_back (p.kopija ()); return *this; }
    Sklop& operator+= (Predmet* p)       //   i preuzimanjem.
      { niz.push_back (p); return *this; }
    Sklop* kopija () const { return new Sklop (*this); }  // Din. kopija.
    double V () const;                   // Zapremina.
    double Q () const;                   // Tezina.
  }; // class Sklop
} // namespace Predmeti

#endif
