// skup2.C - Metode i funkcije uz klasu skupova apstraktnih objekata.

#include "skup2.h"

void Skup::kopiraj (const Skup& s) {       // Kopiranje skupa.
  prvi = posl = 0;
  for (Elem* tek=s.prvi; tek; tek=tek->sled) dodaj (*tek->obj);
}

void Skup::brisi   () {                                    // Unistavanje.
  while (prvi) { Elem* stari = prvi; prvi = prvi->sled; delete stari; }
  posl = 0;
}

bool Skup::operator% (const Obj &obj) const {              // Element skupa?
  for (Elem* tek=prvi; tek; tek=tek->sled)
    if (*tek->obj == obj) return true;
  return false;
}

Skup operator- (const Skup& s1, const Skup& s2) {          // Razlika.
  Skup s;
  for (Skup::Elem* tek=s1.prvi; tek; tek=tek->sled)
    if (! (s2 % *tek->obj)) s.dodaj (*tek->obj);
  return s;
}

Skup operator* (const Skup& s1, const Skup& s2) {          // Presek.
  Skup s;
  for (Skup::Elem* tek=s1.prvi; tek; tek=tek->sled)
    if (s2 % *tek->obj) s.dodaj (*tek->obj);
  return s;
}

Skup& Skup::operator+= (const Skup& s) {                   // Unija.
  for (Skup::Elem* tek=s.prvi; tek; tek=tek->sled)
    if (! (*this % *tek->obj)) dodaj (*tek->obj);
  return *this;
}

ostream& operator<< (ostream& d, const Skup& s) {          // Pisanje.
  d << '{';
  for (Skup::Elem* tek=s.prvi; tek; tek=tek->sled) {
    d << *tek->obj << (tek->sled ? ", " : "");
  }
  return d << '}';
}
