// tekst1.h - Defincija klase tekstova.

#include <iostream>
#include <cstring>
#include <cstdlib>
using namespace std;

class Tekst {
  char* niz;                                    // Pokazivac na sam tekst.
  void kopiraj (const char*);                   // Kopiranje teksta.
  void brisi () { delete [] niz; }              // Unistavanje teksta.
public:                                         // Inicijalizacija:
  Tekst () { niz = 0; }                         //   - kao prazan tekst,
  Tekst (const char* n) { kopiraj (n);  }       //   - nizom znakova,
  Tekst (const Tekst& t) { kopiraj (t.niz);  }  //   - drugim tekstom.
  ~Tekst () { brisi (); }                       // Unistavanje.
  Tekst& operator= (const Tekst& t) {           // Dodela vrednosti.
    if (this != &t) { brisi (); kopiraj (t.niz); }
    return *this;
  }
  friend int len (const Tekst& t)          // Duzina teksta.
    { return t.niz ? strlen (t.niz) : 0; }
  friend Tekst operator+                   // Spajanje tekstova.
    (const Tekst&, const Tekst&);
  Tekst& operator+= (const Tekst& t)       // Dodavanje teksta.
    { return *this = *this + t; }
  char& operator[] (int i) {               // Znak u promenljivom tekstu.
    if (i<0 || len(*this)<=i) exit (1);
    return niz[i];
  }
  const char& operator[] (int i) const {   // Znak u nepromenljivom tekstu.
    if (i<0 || len(*this)<=i) exit (1);
    return niz[i];
  }
  Tekst operator() (int, int) const;                      // Podniz teksta.
  friend int operator% (const Tekst&, const Tekst&);      // Mesto podniza.
  friend ostream& operator<< (ostream& d, const Tekst& t) // Pisanje teksta.
    { if (t.niz) d << t.niz; return d; }
  friend istream& operator>> (istream&, Tekst&);          // Citanje teksta.
};
